'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var util = {
  ImplementsStatics: function ImplementsStatics() {
    return function (constructor) {
    };
  },
  returnUndefined: function returnUndefined(value, theReturn) {
    if (value === undefined) {
      return theReturn;
    } else {
      return false;
    }
  },
  stringToBoolean: function stringToBoolean(value) {
    if (typeof value == "boolean") return value;

    switch (value) {
      case "true":
      case "yes":
      case "1":
        return true;

      case "false":
      case "no":
      case "0":
      case null:
        return false;

      default:
        return Boolean(value);
    }
  },
  typeCheck: function typeCheck(toCheck, defValue) {
    if (toCheck === undefined || toCheck === null || toCheck === "null" || toCheck === "" || defValue === 0 || toCheck === "0" || toCheck === false || toCheck === "false") {
      return defValue;
    } else {
      return toCheck;
    }
  },
  deprecated: function deprecated(deprecationReason) {
    return function (target, memberName, propertyDescriptor) {
      return {
        get: function get() {
          var _this = this;

          var wrapperFn = function wrapperFn() {
            console.warn("Method " + memberName + " is deprecated with reason: " + deprecationReason);

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            propertyDescriptor.value.apply(_this, args);
          };

          Object.defineProperty(this, memberName, {
            value: wrapperFn,
            configurable: true,
            writable: true
          });
          return wrapperFn;
        }
      };
    };
  },
  isBoolean: function isBoolean(arg) {
    return typeof arg === "boolean";
  },
  isNull: function isNull(arg) {
    return arg === null;
  },
  isNullOrUndefined: function isNullOrUndefined(arg) {
    return arg === null || arg === undefined;
  },
  isNumber: function isNumber(arg) {
    return typeof arg === "number";
  },
  isString: function isString(arg) {
    return typeof arg === "string";
  },
  isSymbol: function isSymbol(arg) {
    return typeof arg === "symbol";
  },
  isUndefined: function isUndefined(arg) {
    return arg === undefined;
  },
  isObject: function isObject(arg) {
    return arg !== null && typeof arg === "object";
  },
  isFunction: function isFunction(arg) {
    return typeof arg === "function";
  },
  isPrimitive: function isPrimitive(arg) {
    return arg === null || typeof arg !== "object" && typeof arg !== "function";
  }
};

exports.util = util;
//# sourceMappingURL=extendus.cjs.development.js.map
